Crazy Eddies GUI System: CEGUI::WidgetLookFeel Class Reference

Crazy Eddies GUI System 0.7.6

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions
CEGUI::WidgetLookFeel Class Reference

Class that encapsulates look & feel information for a particular widget type. More...

Collaboration diagram for CEGUI::WidgetLookFeel:
[legend]

List of all members.

## Public Types
typedef std::vector < PropertyInitialiser > | PropertyList
typedef std::vector < PropertyDefinition > | PropertyDefinitionList
typedef std::vector < PropertyLinkDefinition > | PropertyLinkDefinitionList
## Public Member Functions
| WidgetLookFeel (const String &name)
const StateImagery & | getStateImagery (const CEGUI::String &state) const
| Return a const reference to the StateImagery object for the specified state.
const ImagerySection & | getImagerySection (const CEGUI::String &section) const
| Return a const reference to the ImagerySection object with the specified name.
const String & | getName () const
| Return the name of the widget look.
void | addImagerySection (const ImagerySection &section)
| Add an ImagerySection to the WidgetLookFeel.
void | addWidgetComponent (const WidgetComponent &widget)
| Add a WidgetComponent to the WidgetLookFeel.
void | addStateSpecification (const StateImagery &state)
| Add a state specification (StateImagery object) to the WidgetLookFeel.
void | addPropertyInitialiser (const PropertyInitialiser &initialiser)
| Add a property initialiser to the WidgetLookFeel.
void | clearImagerySections ()
| Clear all ImagerySections from the WidgetLookFeel.
void | clearWidgetComponents ()
| Clear all WidgetComponents from the WidgetLookFeel.
void | clearStateSpecifications ()
| Clear all StateImagery objects from the WidgetLookFeel.
void | clearPropertyInitialisers ()
| Clear all PropertyInitialiser objects from the WidgetLookFeel.
void | initialiseWidget (Window &widget) const
| Initialise the given window using PropertyInitialsers and component widgets specified for this WidgetLookFeel.
void | cleanUpWidget (Window &widget) const
| Clean up the given window from all properties and component widgets created by this WidgetLookFeel.
bool | isStateImageryPresent (const String &state) const
| Return whether imagery is defined for the given state.
void | addNamedArea (const NamedArea &area)
| Adds a named area to the WidgetLookFeel.
void | clearNamedAreas ()
| Clear all defined named areas from the WidgetLookFeel.
const NamedArea & | getNamedArea (const String &name) const
| Return the NamedArea with the specified name.
bool | isNamedAreaDefined (const String &name) const
| return whether a NamedArea object with the specified name exists for this WidgetLookFeel.
void | layoutChildWidgets (const Window &owner) const
| Layout the child widgets defined for this WidgetLookFeel which are attached to the given window.
void | addPropertyDefinition (const PropertyDefinition &propdef)
| Adds a property definition to the WidgetLookFeel.
void | addPropertyLinkDefinition (const PropertyLinkDefinition &propdef)
| Adds a property link definition to the WidgetLookFeel.
void | clearPropertyDefinitions ()
| Clear all defined property definitions from the WidgetLookFeel.
void | clearPropertyLinkDefinitions ()
| Clear all defined property link definitions from the WidgetLookFeel.
void | addAnimationName (const String &anim_name)
| Add the name of an animation that is associated with the WidgetLookFeel.
void | writeXMLToStream (XMLSerializer &xml_stream) const
| Writes an xml representation of this WidgetLookFeel to out_stream.
void | renameChildren (const Window &widget, const String &newBaseName) const
| Uses the WindowManager to rename the child windows that are created for this WidgetLookFeel.
const PropertyInitialiser * | findPropertyInitialiser (const String &propertyName) const
| Takes the name of a property and returns a pointer to the last PropertyInitialiser for this property or 0 if the is no PropertyInitialiser for this property in the WidgetLookFeel.
const WidgetComponent * | findWidgetComponent (const String &nameSuffix) const
| Takes the namesuffix for a widget component and returns a pointer to it if it exists or 0 if it does'nt.
const PropertyDefinitionList & | getPropertyDefinitions () const
const PropertyLinkDefinitionList & | getPropertyLinkDefinitions () const
const PropertyList & | getProperties () const

## Detailed Description

Class that encapsulates look & feel information for a particular widget type.

## Member Typedef Documentation

typedef std::vector<PropertyInitialiser> CEGUI::WidgetLookFeel::PropertyList

Typedefs for property related lists.

## Member Function Documentation

void CEGUI::WidgetLookFeel::addAnimationName | ( | const String & | anim_name | ) |

Add the name of an animation that is associated with the WidgetLookFeel.

Parameters:

  anim_name | Reference to a String object that contains the name of the animation to be associated with this WidgetLookFeel.

void CEGUI::WidgetLookFeel::addImagerySection | ( | const ImagerySection & | section | ) |

Add an ImagerySection to the WidgetLookFeel.

Parameters:

  section | ImagerySection object to be added.

Returns:
  Nothing.

void CEGUI::WidgetLookFeel::addNamedArea | ( | const NamedArea & | area | ) |

Adds a named area to the WidgetLookFeel.

Parameters:

  area | NamedArea to be added.

Returns:
  Nothing.

void CEGUI::WidgetLookFeel::addPropertyDefinition | ( | const PropertyDefinition & | propdef | ) |

Adds a property definition to the WidgetLookFeel.

Parameters:

  propdef | PropertyDefinition object to be added.

Returns:
  Nothing.

void CEGUI::WidgetLookFeel::addPropertyInitialiser | ( | const PropertyInitialiser & | initialiser | ) |

Add a property initialiser to the WidgetLookFeel.

Parameters:

  initialiser | PropertyInitialiser object to be added.

Returns:
  Nothing.

void CEGUI::WidgetLookFeel::addPropertyLinkDefinition | ( | const PropertyLinkDefinition & | propdef | ) |

Adds a property link definition to the WidgetLookFeel.

Parameters:

  propdef | PropertyLinkDefinition object to be added.

Returns:
  Nothing.

void CEGUI::WidgetLookFeel::addStateSpecification | ( | const StateImagery & | state | ) |

Add a state specification (StateImagery object) to the WidgetLookFeel.

Parameters:

  section | StateImagery object to be added.

Returns:
  Nothing.

void CEGUI::WidgetLookFeel::addWidgetComponent | ( | const WidgetComponent & | widget | ) |

Add a WidgetComponent to the WidgetLookFeel.

Parameters:

  widget | WidgetComponent object to be added.

Returns:
  Nothing.

void CEGUI::WidgetLookFeel::cleanUpWidget | ( | Window & | widget | ) | const

Clean up the given window from all properties and component widgets created by this WidgetLookFeel.

Parameters:

  widget | Window based object to be cleaned up.

Returns:
  Nothing.

void CEGUI::WidgetLookFeel::clearImagerySections | ( |  | ) |

Clear all ImagerySections from the WidgetLookFeel.

Returns:
  Nothing.

void CEGUI::WidgetLookFeel::clearNamedAreas | ( |  | ) |

Clear all defined named areas from the WidgetLookFeel.

Returns:
  Nothing.

void CEGUI::WidgetLookFeel::clearPropertyDefinitions | ( |  | ) |

Clear all defined property definitions from the WidgetLookFeel.

Returns:
  Nothing.

void CEGUI::WidgetLookFeel::clearPropertyInitialisers | ( |  | ) |

Clear all PropertyInitialiser objects from the WidgetLookFeel.

Returns:
  Nothing.

void CEGUI::WidgetLookFeel::clearPropertyLinkDefinitions | ( |  | ) |

Clear all defined property link definitions from the WidgetLookFeel.

Returns:
  Nothing.

void CEGUI::WidgetLookFeel::clearStateSpecifications | ( |  | ) |

Clear all StateImagery objects from the WidgetLookFeel.

Returns:
  Nothing.

void CEGUI::WidgetLookFeel::clearWidgetComponents | ( |  | ) |

Clear all WidgetComponents from the WidgetLookFeel.

Returns:
  Nothing.

const PropertyInitialiser* CEGUI::WidgetLookFeel::findPropertyInitialiser | ( | const String & | propertyName | ) | const

Takes the name of a property and returns a pointer to the last PropertyInitialiser for this property or 0 if the is no PropertyInitialiser for this property in the WidgetLookFeel.

Parameters:

  propertyName | The name of the property to look for.

const WidgetComponent* CEGUI::WidgetLookFeel::findWidgetComponent | ( | const String & | nameSuffix | ) | const

Takes the namesuffix for a widget component and returns a pointer to it if it exists or 0 if it does'nt.

Parameters:

  nameSuffix | The name suffix of the Child component to look for.

const ImagerySection& CEGUI::WidgetLookFeel::getImagerySection | ( | const CEGUI::String & | section | ) | const

Return a const reference to the ImagerySection object with the specified name.

Returns:
  ImagerySection object with the specified name.

const String& CEGUI::WidgetLookFeel::getName | ( |  | ) | const

Return the name of the widget look.

Returns:
  String object holding the name of the WidgetLookFeel.

const NamedArea& CEGUI::WidgetLookFeel::getNamedArea | ( | const String & | name | ) | const

Return the NamedArea with the specified name.

Parameters:

  name | String object holding the name of the NamedArea to be returned.

Returns:
  The requested NamedArea object.

const PropertyList& CEGUI::WidgetLookFeel::getProperties | ( |  | ) | const`[inline]`

Obtains list of properties. public

Returns:
  CEGUI::WidgetLookFeel::PropertyList List of properties

const PropertyDefinitionList& CEGUI::WidgetLookFeel::getPropertyDefinitions | ( |  | ) | const`[inline]`

Obtains list of properties definitions. public

Returns:
  CEGUI::WidgetLookFeel::PropertyDefinitionList List of properties definitions

const PropertyLinkDefinitionList& CEGUI::WidgetLookFeel::getPropertyLinkDefinitions | ( |  | ) | const`[inline]`

Obtains list of properties link definitions. public

Returns:
  CEGUI::WidgetLookFeel::PropertyLinkDefinitionList List of properties link definitions

const StateImagery& CEGUI::WidgetLookFeel::getStateImagery | ( | const CEGUI::String & | state | ) | const

Return a const reference to the StateImagery object for the specified state.

Returns:
  StateImagery object for the requested state.

void CEGUI::WidgetLookFeel::initialiseWidget | ( | Window & | widget | ) | const

Initialise the given window using PropertyInitialsers and component widgets specified for this WidgetLookFeel.

Parameters:

  widget | Window based object to be initialised.

Returns:
  Nothing.

bool CEGUI::WidgetLookFeel::isNamedAreaDefined | ( | const String & | name | ) | const

return whether a NamedArea object with the specified name exists for this WidgetLookFeel.

Parameters:

  name | String holding the name of the NamedArea to check for.

Returns:
  - true if a named area with the requested name is defined for this WidgetLookFeel.
  - false if no such named area is defined for this WidgetLookFeel.

bool CEGUI::WidgetLookFeel::isStateImageryPresent | ( | const String & | state | ) | const

Return whether imagery is defined for the given state.

Parameters:

  state | String object containing name of state to look for.

Returns:
  - true if imagery exists for the specified state,
  - false if no imagery exists for the specified state.

void CEGUI::WidgetLookFeel::layoutChildWidgets | ( | const Window & | owner | ) | const

Layout the child widgets defined for this WidgetLookFeel which are attached to the given window.

Parameters:

  owner | Window object that has the child widgets that require laying out.

Returns:
  Nothing.

void CEGUI::WidgetLookFeel::renameChildren | ( | const Window & | widget,
|  | const String & | newBaseName
| ) |  | const

Uses the WindowManager to rename the child windows that are created for this WidgetLookFeel.

Parameters:

  widget | The target Window containing the child windows that are to be renamed.
  newBaseName | String object holding the new base name that will be used when constructing new names for the child windows.

void CEGUI::WidgetLookFeel::writeXMLToStream | ( | XMLSerializer & | xml_stream | ) | const

Writes an xml representation of this WidgetLookFeel to out_stream.

Parameters:

  xml_stream | Stream where xml data should be output.

Returns:
  Nothing.